define bi_plenv::cli (
    $command = $title,
    $unless = undef,
    $cwd = undef,
    $user = undef,
    $http_proxy = undef,
    $https_proxy = undef,
    $timeout = undef,
) {
    if $command == undef or !is_string($command) { 
        fail("'command' must be defined") 
    }
    
    if $cwd == undef or !is_string($cwd) { 
        fail("'cwd' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    if $http_proxy != undef and is_string($http_proxy) {
        $arg_http_proxy = "http_proxy=$http_proxy"
    } else {
        $arg_http_proxy = ""
    }
    
    if $https_proxy != undef and is_string($https_proxy) {
        $arg_https_proxy = "https_proxy=$https_proxy"
    } else {
        $arg_https_proxy = ""
    }
    
    $real_command = "$arg_http_proxy $arg_https_proxy $command"
    debug("real_command: $real_command")
    
    bi_bash::exec { "$user: $real_command":
        command => $command,
        unless => $unless,
        user => $user,
        cwd => $cwd,
        timeout => $timeout,
    }
}
