define bi_plenv::cpan::module (
    $package_name = $title,
    $version = undef,
    $test = false,
    $force = undef,
    $reinstall = undef,
    $verbose = undef,
    $quiet = undef,
    $cwd = undef,
    $user = undef,
    $ensure = undef,
    $http_proxy = undef,
    $https_proxy = undef,
) {

    if $ensure == undef or !is_string($ensure) { 
        fail("'ensure' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    case $ensure {
        'present': {
            bi_plenv::cpanm::install { "$user/$package_name":
                package_name => $package_name,
                version => $version,
                test => $test,
                force => $force,
                reinstall => $reinstall,
                verbose => $verbose,
                cwd => $cwd,
                user => $user,
                http_proxy => $http_proxy,
                https_proxy => $https_proxy,
            }
            ->
            bi_plenv::rehash { "$user/rehash for $package_name":
                user => $user,
                cwd => $cwd,
                refreshonly => true,
            }
        }
        
        'absent': {
            bi_plenv::cpanm::uninstall { "$user/$package_name":
                package_name => $package_name,
                version => $version,
                force => $force,
                verbose => $verbose,
                cwd => $cwd,
                user => $user,
                http_proxy => $http_proxy,
                https_proxy => $https_proxy,
            }
            ->
            bi_plenv::rehash { "$user/rehash for $package_name":
                user => $user,
                cwd => $cwd,
                refreshonly => true,
            }
        }
    }
}
