class bi_plenv::cpanm::client_install (
    $cwd = undef,
    $user = undef,
    $http_proxy = undef,
    $https_proxy = undef,
) {
    if $cwd == undef or !is_string($cwd) { 
        fail("'cwd' must be defined") 
    }

    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    if $http_proxy != undef and is_string($http_proxy) {
        $arg_http_proxy = "http_proxy=$http_proxy"
    } else {
        $arg_http_proxy = ""
    }
    
    if $https_proxy != undef and is_string($https_proxy) {
        $arg_https_proxy = "https_proxy=$https_proxy"
    } else {
        $arg_https_proxy = ""
    }
    
    $command = "$arg_http_proxy $arg_https_proxy plenv install-cpanm"
    debug("command: $command")
    
    $unless = "perl -e \"use App::cpanminus\""
    debug("unless: $unless")
    
    require ::bi_plenv
    
    bi_bash::exec { "$user/$command":
        command => $command,
        unless => $unless,
        user => $user,
        cwd => $cwd,
    }
    ->
    bi_plenv::rehash { "$user/rehash for install-cpanm":
        user => $user,
        refreshonly => true,
        cwd => $cwd,
    }
}
