define bi_plenv::version (
    $version = $title,
    $user = undef,
    $ensure = undef,
    $http_proxy = undef,
    $https_proxy = undef,
) {

    if $version == undef or !is_string($version) { 
        fail("'version' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    if $ensure == undef or !is_string($ensure) { 
        fail("'ensure' must be defined") 
    }
    
    include ::bi_plenv
    require ::bi_grep
  
    bi_anyenv::env::plenv { $user: 
        http_proxy => $http_proxy,
        https_proxy => $https_proxy,
    }
    
    if $http_proxy != undef and is_string($http_proxy) {
        $arg_http_proxy = "http_proxy=$http_proxy"
    } else {
        $arg_http_proxy = ""
    }
    
    if $https_proxy != undef and is_string($https_proxy) {
        $arg_https_proxy = "https_proxy=$https_proxy"
    } else {
        $arg_https_proxy = ""
    }
    
    $command = "$arg_http_proxy $arg_https_proxy plenv install $version"
    debug("command: $command")
    
    $unless = "plenv versions | $::bi_grep::exe_path $version"
    debug("unless: $unless")
    
    bi_bash::exec { "user[$user]: $command":
        command => $command,
        unless => $unless,
        user => $user,
        require => [
            Bi_anyenv::Env::Plenv[$user],
        ]
    }
}
