define bi_plenv::version_file (
    $version = undef,
    $project_dir = $title,
    $owner = undef,
    $group = undef,
    $mode = '755',
    $ensure = 'present',
) {

    if $version == undef or !is_string($version) { 
        fail("'version' must be defined") 
    }
    
    if $owner == undef or !is_string($owner) { 
        fail("'owner' must be defined") 
    }
    
    if $ensure == undef or !is_string($ensure) { 
        fail("'ensure' must be defined") 
    }
    
    if $group == undef or !is_string($group) { 
        fail("'group' must be defined") 
    }
    
    if $project_dir == undef or !is_string($project_dir) { 
        fail("'project_dir' must be defined") 
    }
    
    include ::bi_plenv
    
    file { "$project_dir/.perl-version":
        ensure => $ensure,
        owner => $owner,
        group => $group,
        mode => $mode,
        content => template("$module_name/perl-version.erb"),
    }
    
}
